#include "xitg.c"

#define HOROKRAJ      70
#define ODRPRAVO SIRKAHR
#define ODRLEVO        0
#define HRXL   SIRKAHR/2-12
#define HRXP   SIRKAHR/2+12
#define HRY      VYSKAHR

#define GRAVITACE  0.8
#define STZRYCH    0.3
#define STTRENI    0.9
#define STBRZDA    0.7
#define STSTART    STZRYCH
#define MAXRYCH  12.2

#define LETI           0
#define STOJI          1
#define PRASKA         2

int hrfaze, hrstav, hrx, hry, hrsmer, cislopatra, nadpatrem;
int spadnul, posunuj, maxpatro;
int hodiny;
float hrxx, hryy, fx;

int carx[CARU], cary[CARU];
float carxx[CARU], caryy[CARU];

struct patro hrpatro;

int patfaze;

int zaokrouhli(float cislo)
{
  /*  if(cislo >= ((int)cislo)+0.5) return (int)cislo+1;
      else*/ return (int)cislo;
}

int maxpatdelka;
void vymyslip(Window w)
{
  struct patro topatro;
  int delka;
  
  if((pocetpater+pocetpat2) % 50 == 0){
    topatro.zacatek = 0;
    topatro.konec = SIRKAW;
  }
  else {
    if((pocetpater+pocetpat2) % 30 == 0 && maxpatdelka > 6)
      maxpatdelka--;
    if((pocetpater+pocetpat2) % 500 == 0 &&
       (pocetpater+pocetpat2) >= 1000 && maxpatdelka > 2)
      maxpatdelka--;
    if(maxpatdelka > 6){
      delka = random()%(maxpatdelka-5)+5;
    }
    else delka = maxpatdelka-1;
    topatro.zacatek = random()%(29-delka)*16-18;
    topatro.konec = topatro.zacatek+16*delka+57;
    if(topatro.zacatek == -19) topatro.zacatek = 0;
    else topatro.zacatek += HRXL;
    if(topatro.konec == 487) topatro.konec = SIRKAW;
    else topatro.konec -= HRXP;
  }
  topatro.vyska = poslpat;
   kreslipat(topatro, w);
  patfaze = (patfaze+10)%410;
}

int spoctiskok()
{
  float i;
  i=12.8*hrxx/6.1;
  if(i<12.8) i=12.8;
  return -i;

  if(hrxx <  60)  return -128;
  if(hrxx <  90) return -160;
  if(hrxx < 120) return -196;
  if(hrxx < 122) return -228;
//  if(hrxx < 200)
    return -256;
//  if(hrxx < 300) return -31;
//  return -57;
}

int napatre(){
  if(hrpatro.zacatek < hrx+HRXP && hrx+HRXL < hrpatro.konec) return 1;
  return 0;
}

void skoc(){
  if(hrstav != STOJI) return;
  hrstav = LETI;
  hrfaze = 0;

  hryy = spoctiskok();
}

void inithru(){
  fx = hrx = (SIRKAW-SIRKAHR)/2;
  hrxx = 0;
  hry = VYSKAW-VYSKAPICH-VYSKAPAT-VYSKAHR;
  spadnul = 0;
  maxpatro = 0;
  cislopatra = 0;
  nadpatrem = 0;
  hrstav = STOJI;
  patfaze = 0;
  hrfaze = hrx;
  hrsmer = 0;
  posunuj = 0;
  hodiny = 0;
  maxpatdelka = 14;
}

void restart()
{
  inithru();
  zmenvichr(rmic[0], shapehr, hrx, hry);
  restartpoz();
}

int main(argc, argv)
     int argc;
     char **argv;
{
  initg(argc, argv);
  nactiobry();
  inithru();
  vytvorokno(argc, argv);
  vytvorpoz();
  vytvorpich();
  vytvorhr(rmic[0],hrx,hry);
  initimer();
}

void jedu()
{
  int i, zbyvacaru;

  if(posunuj && posunuj<4) hodiny++;
  if(hodiny == 1800){
    hodiny=0;
    posunuj++;
    printf("HURRY UP: %d, %d\n", posunuj-1, cislopatra);
  }

  if(hrstav == PRASKA){
    zbyvacaru=0;
    for(i=0; i<8; i++)
      if(caryy[i]<0 || cary[i]<VYSKAW){
	zbyvacaru++;
	caryy[i]+= GRAVITACE;
	carx[i] += carxx[i];
	if(carx[i]<0){
	  carx[i]=0;
	  carxx[i] *= -1;
	}
	if(carx[i]>SIRKAW){
	  carx[i]=SIRKAW;
	  carxx[i] *= -1;
	}
	cary[i] += caryy[i];
	posuncar(carx[i], cary[i], i);
      }
    if(!zbyvacaru){
      ukazhr();
      for(i=0; i<8; i++) zniccar(i);
      restart();
    }
    return;    
  }

  if(HRY+hry >= VYSKAW-VYSKAPICH){
    printf("KONEC, doskakal jste do patra %d\n", maxpatro);
    hrstav = PRASKA;
    zmizhr();

    carxx[0] = -1; caryy[0] = -2;
    carxx[1] = 1;  caryy[1] = -2;
    carxx[2] = 2;  caryy[2] = -1;
    carxx[3] = 2;  caryy[3] = 1;
    carxx[4] = 1;  caryy[4] = 2;
    carxx[5] = -1; caryy[5] = 2;
    carxx[6] = -2; caryy[6] = 1;
    carxx[7] = -2; caryy[7] = -1;

    carx[0]=hrx+13; cary[0]=hry+7;
    carx[1]=hrx+25; cary[1]=hry+7;
    carx[2]=hrx+33; cary[2]=hry+13;
    carx[3]=hrx+33; cary[3]=hry+25;
    carx[4]=hrx+25; cary[4]=hry+33;
    carx[5]=hrx+13; cary[5]=hry+33;
    carx[6]=hrx+7;  cary[6]=hry+25;
    carx[7]=hrx+7;  cary[7]=hry+13;

//    printf("hrxx: %d\n", hrxx);
    for(i=0; i<8; i++){
      carxx[i] = carxx[i]+hrsmer*hrxx/2;
      caryy[i] = caryy[i]-hryy/2;
      vytvorcar(carx[i],cary[i],i);
    }

    return;
  }

  int ohry, mezihry;

  if(vlevo == vpravo){
    hrxx*=STTRENI;
  }
  else if(hrxx == 0){
    hrsmer = vpravo - vlevo;
    hrxx = STSTART;
  }
  else if(hrsmer != vpravo-vlevo){
    hrxx = hrxx*STBRZDA-STZRYCH;
    if(hrxx <= 0){
      hrsmer = -hrsmer;
      hrxx = -hrxx;
    }
  }
  else{
    hrxx+=STZRYCH;
    if(hrxx > MAXRYCH) hrxx = MAXRYCH;
  }
  fx += hrxx*hrsmer;
  
  if(hrsmer == 1 && fx > SIRKAW-ODRPRAVO){
    fx = SIRKAW-ODRPRAVO;
    hrsmer = -1;
  }
  if(hrsmer == -1 && fx < ODRLEVO){
    fx = ODRLEVO;
    hrsmer = 1;
  }

  hrx = (int)fx;

  hry += posunuj;
  if(hrstav == STOJI && hry+HRY >= VYSKAW-VYSKAPICH){
    hryy = 0;
    hrstav = LETI;
    hrfaze = 0;
  }

  if(hrstav == STOJI && !napatre()){
    hrstav = LETI;
    hrfaze = 0;
  }

  if(skok) skoc();
  if(hrstav == LETI){
    ohry = hry;
    hry += hryy;
    if(hryy > 0){
//      printf("1) %d=%d+%d\n", ohry+nadpatrem, ohry, nadpatrem);
      for(mezihry = ohry+nadpatrem; mezihry < hry &&
	    mezihry+HRY < VYSKAW-VYSKAPICH; mezihry += MEZIPAT){
	hrpatro = ziskejpatro(cislopatra);
	if(napatre()){
//	  printf(" huu \n");
	  hry = mezihry;
	  hrstav = STOJI;
	  hrfaze = hrx;
	  break;
	}
	cislopatra--;
      }
      nadpatrem = mezihry - hry;
//      printf("2) %d=%d-%d\n", nadpatrem, mezihry, hry);
    }
    else{
      /*      printf("%d-%d+%d/%d", hry,ohry,nadpatrem,MEZIPAT);*/

      cislopatra += (ohry-hry+nadpatrem)/MEZIPAT;
      if(cislopatra>maxpatro){
	if(cislopatra/50 != maxpatro/50) printf("PATRO: %d\n", cislopatra);
	maxpatro = cislopatra;
      }	
      nadpatrem = (ohry-hry+nadpatrem)%MEZIPAT;

      if(hry < HOROKRAJ){
	posunpoz(HOROKRAJ-hry);
	hry = HOROKRAJ;
	if(cislopatra==5 && !posunuj) posunuj = 1;
      }
//      printf("--> %d, %d", cislopatra, nadpatrem);
//      printf("    STAV = %d, hryy = %d\n", hrstav, hryy);
    }
    hryy += GRAVITACE;
  }

  if(hry > VYSKAW){
    hry = VYSKAW;
    spadnul = 1;
  }

  if(hrstav == LETI){
    hrfaze = (12+hrfaze+hrsmer)%12;
    zmenhr(smic[hrfaze/2], hrx, hry);
  }
  else{
    i=(hrx-hrfaze)/10%10;
    if(i<0) i+=10;
    zmenhr(rmic[i], hrx, hry);
  }

  if(posunuj) posunpoz(posunuj);
}
